local sampev = require("lib.samp.events") --  
local bit = require("bit") --   
local band, bor, shl = bit.band, bit.bor, bit.lshift --  

local EPSILON = 0.0001
local MAX_TEXTDRAWS = 2304
local INTERVAL_SLOT_CLICK = 100 --  
local INTERVAL_DIALOG_CLOSE = 1 --   
local INTERVAL_PAGE_CHANGE = 1000 --    
local active = false

--    ()
local lavka_slots = {
   {184.5, 164.74285888672}, {211, 164.74285888672}, {237.5, 164.74285888672}, {264, 164.74285888672}, {290.5, 164.74285888672},
   {184.5, 195.24285888672}, {211, 195.24285888672}, {237.5, 195.24285888672}, {264, 195.24285888672}, {290.5, 195.24285888672},
   {184.5, 225.74285888672}, {211, 225.74285888672}, {237.5, 225.74285888672}, {264, 225.74285888672}, {290.5, 225.74285888672},
   {184.5, 256.24285888672}, {211, 256.24285888672}, {237.5, 256.24285888672}, {264, 256.24285888672}, {290.5, 256.24285888672},
   {184.5, 286.74285888672}, {211, 286.74285888672}, {237.5, 286.74285888672}, {264, 286.74285888672}, {290.5, 286.74285888672},
   {184.5, 317.24285888672}, {211, 317.24285888672}, {237.5, 317.24285888672}, {264, 317.24285888672}, {290.5, 317.24285888672},
}

--   ">" ()
local buttons = {
   next = {264.12396240234, 357.74285888672},
}

--     
--     
local dynamic_slots, dynamic_buttons = {}, {}

--     
--  
local current_td, time = 0, 0 -- 

--    
--   
local function isLavkaSlot(x, y)
   for _, position in ipairs(lavka_slots) do
      if math.abs(position[1] - x) < EPSILON and math.abs(position[2] - y) < EPSILON then
         return true
      end
   end
   return false
end

--    
--     
-- 
local function isNextButton(x, y)
   return math.abs(buttons.next[1] - x) < EPSILON and math.abs(buttons.next[2] - y) < EPSILON
end

--    , 
--    ,  
--       
-- 
local function parseSlots()
   dynamic_slots, dynamic_buttons = {}, {}
   for id = 0, MAX_TEXTDRAWS do
      if sampTextdrawIsExists(id) then
         local td_x, td_y = sampTextdrawGetPos(id)
         if isLavkaSlot(td_x, td_y) then
            table.insert(dynamic_slots, id)
         elseif isNextButton(td_x, td_y) then
            table.insert(dynamic_buttons, id)
         end
      end
   end
end

--      
function renderTDSelection()
   if active then
   if sampTextdrawIsExists(current_td) then
      local td_px, td_py = sampTextdrawGetPos(current_td)
      local _, _, td_sx, td_sy = sampTextdrawGetBoxEnabledColorAndSize(current_td)
      local wposX, wposY = convertGameScreenCoordsToWindowScreenCoords(td_px, td_py)
      local wsizX, wsizY = convertGameScreenCoordsToWindowScreenCoords(td_sx, td_sy)
      
      --    (, )  
      local fillR = 255 -- 
      local fillG = 0   -- 
      local fillB = 0   -- 
      local alpha = 0   --    

      --    
      local fillColor = bor(shl(alpha, 24), shl(fillB, 16), shl(fillG, 8), fillR)
      
      --   
      renderDrawBox(wposX, wposY, wsizX, wsizY, fillColor)

      --    (, )
      local borderR = 0   -- 
      local borderG = 255   -- 
      local borderB = 0   -- 
      local borderAlpha = 255 --   

      --   
      local borderColor = bor(shl(borderAlpha, 24), shl(borderB, 16), shl(borderG, 8), borderR)

      --   ()   
      renderDrawBox(wposX, wposY, wsizX, 5, borderColor) --  
      renderDrawBox(wposX, wposY + wsizY - 2, wsizX, 5, borderColor) --  
      renderDrawBox(wposX, wposY, 5, wsizY, borderColor) --  
      renderDrawBox(wposX + wsizX - 2, wposY, 5, wsizY, borderColor) --  
      end
   end
end



function main()
   if not isSampLoaded() or not isSampfuncsLoaded() then return end
   while not isSampAvailable() do wait(0) end
   sampAddChatMessage("{FFFFFF}[{00FF00}lavkaparser{FFFFFF}]:  {DC143C}/scan", -1)
   sampRegisterChatCommand("scan", function ()
      active = not active
      lua_thread.create(function ()
         while sampIsDialogActive() do wait(0) end
         --   
         for page = 1, 3 do
            parseSlots()
            sampAddChatMessage("{FF0000}current page:{FFFFFF}" .. page, -1)
            --    
            for _, td_id in ipairs(dynamic_slots) do
               current_td = td_id
               if sampTextdrawIsExists(td_id) then
                  sampSendClickTextdraw(td_id)
                  wait(INTERVAL_SLOT_CLICK)
               else
                  sampAddChatMessage("{FF0000}failed, textdraw:{FFFFFF}" .. td_id, -1)
                  break
               end
            end
            --     - 
            --    
            wait(200)
            current_td = dynamic_buttons[1]
            sampSendClickTextdraw(dynamic_buttons[1])
            wait(INTERVAL_PAGE_CHANGE)
         end
         sampAddChatMessage("{FF0000}parse end", -1)
         active = false
      end)
   end)
   while true do wait(0) renderTDSelection() end
end


function sampev.onShowDialog(dialogId, style, title, button1, button2, text)
   if active then
   if title:match('{BFBBBA} ') then 
       local foundItem = false 
       local itemData = {}

       for line in text:gmatch("[^\n]+") do
           local predmed = line:match('{FFFFFF}:%s{......}(.-){......}')
           local money = text:match(':%s%$([%,%.%d]+)') or "0"

           if predmed then
               sampAddChatMessage(predmed..' {FFFFFF}'..money, 0x00FF00) 
               --sampAddChatMessage(' ', 0xFF1493)
               foundItem = true 
               predmed = predmed:gsub('{%x%x%x%x%x%x}', '')
               local priceValue = money:gsub('%.', ''):gsub(',', '')
               local itemEntry = {
                   number = 0,
                   price = tonumber(priceValue) or 0,
                   name = predmed,
                   enabled = true,
                   maximum = true,
                   number_dynamic = 0,
               }
               table.insert(itemData, itemEntry)
               break 
           end
       end
     
       if not foundItem then
           local alternativeText = text:match('^%C+')
           local money = text:match(':%s%$([%,%.%d]+)') or "0"
           if alternativeText then
               alternativeText = alternativeText:gsub(':%s*', ''):gsub(':%s*', ''):gsub(':%s*', '')
              
               --sampAddChatMessage(' ', 0xFF1493)
               alternativeText = alternativeText:gsub('{%x%x%x%x%x%x}', '')
               local priceValue = money:gsub('%.', ''):gsub(',', '')
               sampAddChatMessage(alternativeText..' {FFFFFF}'..money, 0x00FF00) 
               local altItemEntry = {
                   number = 0,
                   price = tonumber(priceValue) or 0,
                   name = alternativeText,
                   enabled = true,
                   maximum = true,
                   number_dynamic = 0,
               }
               table.insert(itemData, altItemEntry)
           end
       end
       
       if #itemData > 0 then
           local file = io.open("moonloader/config/Palatka - Arizona RP/buy/items.cfg", "a")
           if file then
               for _, item in ipairs(itemData) do
                   file:write(string.format("table.insert(tbl, {\n    number = %d,\n    price = %d,\n    name = \"%s\",\n    enabled = %s,\n    maximum = %s,\n    number_dynamic = %d,\n})\n", 
                       item.number, 
                       item.price, 
                       item.name, 
                       tostring(item.enabled), 
                       tostring(item.maximum), 
                       item.number_dynamic))
               end
               file:close()
           else
               sampAddChatMessage("     !", -1)
           end
       end
       end
       lua_thread.create(function ()
         -- 
         wait(INTERVAL_DIALOG_CLOSE)
         --   
         sampSendDialogResponse(id, 0, nil, nil)
         sampCloseCurrentDialogWithButton(0)
      end)       
   end    
end
